# Libakrypt: перечень изменений


## Изменения в версии 0.9.14

 - Добавлена реализация хэш-таблицы с возможностью поиска данных,
   сохранения/чтения таблицы, а также проверки уникальности ключа поиска
 - Переписана большая часть команды icode для утилиты aktool
    - теперь поддерживается контроль целостности как загружаемых,
      так и уже загруженных сегментов исполняемого кода и данных,
    - реализована поддержка файлов конфигурации
 - Исправлена реализации функции ak_file_read_by_lines
 - Исправлена ошибка при чтении секретных ключей с паролем нулевой длины
 - Исправлена ошибка при отображении файлов в память (функция ak_file_mmap)
 - Уточнены имена ряда статических (неэкспортируемых) функций библиотеки
 - Исправлены неточности в механизме сборки документации


## Изменения в версии 0.9.13
 
 - Добавлены функции для чтения и записи открытых ключей в простом текстовом формате
     - ak_verifykey_create_from_file()
     - ak_verifykey_export_to_file()
 - Реализация некриптографической функции crc64 (стандарт: ECMA 182, Прил. B)
    - ak_hash_create_crc64()  
 - Добавлены функции, связывающие численные идентификаторы кривых и их параметры
    - ak_wcurve_get_identifier()
    - ak_wcurve_get_parameters()
 - Добавленный функционал утилиты aktool:
    - появилась возможность удаления файлов после изменения формата
      представления asn1 данных (pem или der)


## Изменения в версии 0.9.12

 - Преобразован раздел с функциями генерации производных ключей.
   Изменены или добавлены следующие функции:
    - int ak_skey_derive_kdf256()
    - int ak_skey_derive_kdf256_from_skey()
    - ak_pointer ak_skey_new_derive_kdf256_from_skey()
    - int ak_tlstree_state_create()
    - int ak_tlstree_state_destroy()
    - int ak_skey_derive_tlstree()
    - int ak_skey_derive_tlstree_from_skey()
    - ak_pointer ak_skey_new_derive_tlstree_from_skey()       
 - Встроены в общее дерево тестов криптографических преобразований:
    - ak_libakrypt_test_kdf256()
    - bool_t ak_libakrypt_test_tlstree()
 - Добавлен ряд забытых когда-то функций для кодирования/декодирования base64:
    - const char *ak_ptr_to_base64()
    - char *ak_ptr_to_base64_alloc()
    - size_t ak_ptr_to_base64_size()
    - ak_uint8 *ak_base64_to_ptr()   
 - Название функции ak_skey_delete_after_load() укоротилось до ak_skey_delete()
 - Изменена строка с авторами библиотеки в файле с лицензией


## Изменения в версии 0.9.11

 - Возвращена реализация ПДСЧ на основе функций хеширования (hrng)
 - Изменена команда для подписи сертификатов открытого клчюа в утилите aktool 
   (произведена замена --cert на --sign)
 - Добавлен ряд функций для работы с сертификатами, в том числе:
    - int ak_certificate_export_to_repository() 
    - int ak_certificate_add_file_to_repository()
    - int ak_certificate_add_ptr_to_repository()
    - int ak_certificate_add_asn1_to_repository()
    - int ak_certificate_import_from_repository
 - Добавлена возможность сборки библиотеки с musl вместо libc
 - Реализована поддержка petalinux
 - Существенно расширена документация к библиотеке
 
 
## Изменения в версии 0.9.10

 - Исправлена ошибка в реализации алгоритма nmac [функции finalize и create_nmac_...()]
 - Через интерфейс aead реализованы алгоритмы, комбинирующие шифрование в режиме счетчика и
   вычисление имитовставки через hmac (streebog256, streebog512, nmac)
 - Добавлены следующие функции:
    - ak_skey_delete_after_load()
    - ak_skey_export_to_file_unencrypted()
    - ak_aligned_free() [для поддержки msvc 2022]
 - Добавлены генераторы псевдослучайных последовательностей:
    - nlfsr (нелинейный рекуррентный генератор с квадратичной обратной связью) 
 - Добавленный функционал утилиты aktool:
    - выработка незашифрованных секретных ключей (опция --no-outpass)
    - расширена процедура тестирования алгоритмов блочного шифрования
 - Функция ak_libakrrpt_get_home_path() переименована в ak_homepath()
 - Сокращён перечень обязательных флагов компиляции, принудительно устанавливаемых в MakeFlags.cmake
 - Сборка документации производится теперь под управлением sphinx
   (цель сборки make doc оставлена без изменений, результирующие файлы помещаются в подкаталог doc)


## Изменения в версии 0.9.9

 - Реализован алгоритм выработки имитовставки NMAC
 - Добавлены функции выработки производной ключевой информации,
   согласно Р 1323565.1.022-2018 (см. kdf-example.c)
 - Увеличены максимальные объемы информации, обрабатываемой на одном ключе
   (для алгоритмов Магма, Кузнечик и HMAC)
 - Уточнена реализация функций ak_bckey_cmac_clean()/_update()/_finalize(), ak_certificate_set_repository()
 - Реализована структура для пошаговой реализации aead алгоритмов
   (с поддержкой следующих aead алгоритмов:
     - mgm-magma, mgm-kuznechik,
     - xtsmac-magma, xtsmac-kuznechik,
     - ctr-cmac-magma, ctr-cmac-kuznechik
   )
 - Добавлена поддержка в сертификатах открытых ключей нестандартизированного расширения,
   содержащего номер секретного ключа (SecretKeyNumber)
 - Расширен функционал утилиты aktool
    - реализован вывод отдельных полей секретных ключей (опции --show-...), включая метки
    - добавлена поддержка чтения паролей доступа в консоли для ключей шифрования контейнеров
    - реализованы команды для асимметричного шифрования/расширования файлов
      (альтернатива стандарту CMS)(в тестовом режиме)
    - перед шифрованием, опционально, реализована поддержка сжатия bzip2
    - возвращена частичная русификация консольного интерфейса
  - Протестирована сборка библиотеки msvc в Windows 10 и clang в FreeBSD


## Изменения в версии 0.9.8

 - Скорректирована сборка библиотеки в Windows 10
    - msvc19 (с использованием nmake)
    - mingw64 8.1  (входит в стандартную поставку Qt 6.1)
    - mingw64 10.2 (доступен с msys2.org)
 - Исправлена ошибка хеширования/имитозащиты файлов с пробелами в именах
 - Изменена кодовая страница консоли в Windows для вывода русских символов
 - Добавлен ряд новых OID, в частности, INNLE (инн юридического лица)
 - Исправлена ошибка при выводе владельца/эмитента сертификата без common name
 - Добавлены функции тестирования содержимого asn1 дерева
   ak_asn1_is_(request, certificate, p7b )
 - Утилита aktool теперь может верифицировать и добавлять в репозиторий  
   последовательности сертификатов, содержащиеся в p7b контейнерах (формат cms),
   создавать, выводить в консоль и разделять на отдельные сертификаты 
   содержимое p7b контейнеров.


## Изменения в версии 0.9.7

 - Изменено поведение функции ak_bckey_cmac(),
   теперь она вычисляет имитовставку для данных нулевой длины.
 - Добавлена функция ak_bckey_cmac_file()
 - Реализована возможность вычисления контрольных сумм и имитовставок для файлов,
   с использованием выработанных ранее секретных ключей.
   Поддерживаются алгоритмы: hmac-*, cmac-* и все реализованные функции хеширования.
   Реализована проверка полученных ранее значений.
 - Добавлена функция ak_skey_new_derive_kdf256()
 - Расширена документация к утилите aktool
 - Добавлен тестовый скрипт icode.sh (.csh для отладки под FreeBSD)
 - Уточнен скрипт инсталляции 


## Изменения в версии 0.9.6

 - Изменен интерфейс функций экспорта и импорта открытых ключей
   ( появились функции 
       ak_request(certificate)_export_to ...
       ak_request(certificate)_import_from ...
       ak_request(certificate)_destroy() 
   )
 - увеличен список аргументов функции ak_asn1_import_from_file()
 - реализована проверка цепочек сертификатов, сделан скрипт проверки
 - тестовые скрипты выделены в отдельный каталог дерева исходных кодов


## Изменения в версии 0.9.5

 - Флаги состояний ключа внесены в одно перечисление key_flag_values_t
 - Уточнена реализация следующих функций
    - ak_wipe_ptr()
    - ak_skey_load_from_file() [теперь возвращается NULL в случае ошибки]
    - ak_verifykey_verify_ptr()
    - ak_verifykey_import_from_asn1_extensions()
    - ak_ptr_load_from_base64_file()
    - ak_verifykey_import_from_request() [выделяется буффер в случае нехватки памяти]
    - ak_asn1_add_mpzn() [убрана поддержка отрицательных чисел]
 - Добавлены функции
    - ak_printf()
    - ak_verifykey_import_from_repository_file()
    - ak_verifykey_import_from_repository_ptr()
 - Функции экспортируются:
    - ak_verifykey_export_to_asn1_request()
 - Возвращена русификация утилиты aktool
 - В aktool добавлены функции для работы с базой сертификатов УЦ
 - Исправлены ошибки:
    - при интерпретации случайных данных в качестве asn1
    - при чтении запросов на сертификат нулевой длины
    - в CMakeLists.txt при сборке документации (обработка отсутствующих программ)


## Изменения в версии 0.9.4

 - Исправлена неточность в реализации алгоритма Кузнечик
 - Изменено место расположения генеруемого cmake файла libakrypt-base.h
 - Добавлена команда сборки make pdf
 - Удалены лишние опции библиотеки (см. файл libakrypt.conf)
 - Реализован импорт сертификатов открытых ключей
 - Расширен функционал утилиты aktool, в частности,
   - реализована возможность передавать расширенное имя пользователя через командную строку
    (при создании сертификатов и запросов на сертификат)
   - реализована возможность проводить проверку корректности (верификацию) сертификатов и
     запросов на сертификат открытых ключей
   - проведено тестирование "работы на встречу" с форматом сертификатов библиотеки openssl
    (соответствующий скрипт добавлен в дерево исходных текстов библиотеки)


## Изменения в версии 0.9.3

 - Структура секретного ключа (struct skey) дополнена полем label (метка ключа)
 - Из секретного ключа подписи (struct signkey) удалено обобщенное имя
 - Исправлена ошибка при инициализации ресурса секретного ключа электронной подписи
 - Оптимизирована реализация функций импорта ключевой информации
   (struct bckey, struct hmac, struct signkey ), теперь можно считывать параметры секретного ключа
   без считывания собственно ключевой информации
 - Реализована процедуры генерации, а также экспорта и импорта ключей для схемы Блома (struct blomkey)
 - Сделана трехшаговая реализация алгоритма cmac (с возможностью обновления контекста)
 - Расширен функционал утилиты aktool, в частности,
    - реализован вывод информации о созданных секретных ключах
    - исправлены процедуры создания запросов на сертификат и самоподписанных
      сертификатов открытых ключей
    - реализована работа с ключами схемы Блома
 - Уточнена документация к функциям библиотеки и утилите aktool


## Изменения в версии 0.9.2

 - Сделан интерфейс для доступа к режимам работы, а также процедурам обработки ключевой информации, 
   через механизм oid
 - Увеличен перечень идентификаторов, доступных через механизм oid
 - Реализованы режим работы блочных шифров: xts, а также 
   режимы аутентфицированного шифрования: ctr-cmac, ctr-hmac и xtsmac
   (реализация ctr-cmac и ctr-hmac носит экспериментальный характер)
 - В утилиту aktool добавлены тесты скорости режимов работы блочных шифров


## Изменения в версии 0.9.1

 - Базовая часть библиотеки и платформозависимые функции вынесены в отдельный объектный модуль
   (теперь собираются две библиотеки: 
     - libakrypt-base, библиотека с платформозависимыми и не криптографическими функциями,
     - libakrypt, библиотека с криптографическими преобразованиями )
 - Удалены функции внешнего интерфейса, это привело к изменению названия большого числа
   экспортируемых функций
 - Оставлен только один инсталлируемый заголовочный файл libakrypt.h
 - Добавлен заголовочный файл libakrypt-internal.h для неэкспортируемых функций
 - С настоящего момента собираются два комплекта документации: для каждой разделяемой 
   библиотеки отдельно
 - Возвращена реализация MGM, потерянная в восьмой версии библиотеки
 - В утииту aktool добавлены функции тестирования корректности и скорости работы


## Изменения в версии 0.8.5

 - Изменена внутренняя структура ak_oid и реализация функций поиска идентификаторов
 - Восстановлена реализация потеряных когда-то за ненадобностью режимов шифрования ofb, cfb и acpkm
 - Изменена реализация функции сохранения файлов в pem-формате
 - В утилиту aktool добавлен ряд функций тестирования работоспособности библиотеки
   и скорости выполнения криптографических алгоритмов


## Изменения в версии 0.8.4

 - Исправлены ошибки asn1 декодирования узлов, содержащих время
 - Добавлена поддержка кодировки base64
    - реализована функция ak_ptr_load_from_base64_file()
    - утилита aktool корректно декодирует pem сертификаты
      (последовательно декодируя сначала base64, а потом asn.1)
    - реализован механизм чтения/записи ключевой информации в pem формате
 - Реализован экспорт и импорт открытого ключа из запроса на сертификат согласно Р 1323565.1.023-2018
    - ak_verifykey_context_import_from_request()
    - ak_verifykey_context_export_to_request()
 - Реализован экспорт открытого ключа в сертификат согласно Р 1323565.1.023-2018
   с поддержкой ряда обязательных расширений согласно RFC5280.
    - ak_verifykey_context_export_to_certificate()
 - Добавлены функции внешнего
    - ak_string_read()
   и внутреннего интерфейса
    - ak_mpzn_to_hexstr_alloc()
    - ak_mpzn_rem_uint32()
    - ak_asn1_context_exclude()
 - Уточнен интерфейс функций создания секретных ключей ЭП
   - ak_signkey_context_create_...()
 - Добавлены собственные (нестандартизированные) параметры эллиптической кривой (axel-n0)
 - Изменен интерфейс ряда функций внешнего интерфейса для работы
   с дескрипторами криптографических механизмов.
 - Расширен функционал утилиты aktool в части
   - обработки ASN.1 деревьев (split, convert)
   - создания симметричных и асимметричных секретных ключей,
   - создания запросов на сертификат и собственно сертификатов открытых ключей
 - Добавлен парсер ini-файлов и более корректно реализованы чтение и проверка опций библиотеки


## Изменения в версии 0.8.3

 - Исправлена ошибка при релизации маскирования ключа для алгоритма Магма
 - Для блочных шифров Кузнечик и Магма реализованы:
    - режим простой замены с зацеплением (cbc) согласно ГОСТ Р 34.13-2015 (с поддержкой длинных синхропосылок)
    - режим выработки имитовставки согласно ГОСТ Р 34.13-2015
    - алгоритму вычисления имитовставки ГОСТ Р 34.13-2015 возвращено название `cmac`
     (хотя более корректно использовать `omac1`)
 - Формат вырабатываемой электронной подписи приведен к виду Р 1323565.1.023-2018
 - Реализованы и отлажены ASN.1 парсер и кодировщик в DER-формат;
 - Функционал разбора ASN.1 структур, а фактически - сертификатов ключей, добавлен в утилиту aktool
 - Добавлена документация к утилите aktool
 - Реализован экспорт и импорт секретных ключей в виде ASN.1 деревьев (der-последовательностей)
   экспорт: ak_key_context_export_to_derfile_with_password()
   импорт:  ak_bckey_context_import_from_derfile()
            ak_hmac_context_import_from_derfile()
            ak_signkey_context_import_from_derfile()
 - Добавлены функции внешнего интерфейса
    - ak_libakrypt_set_openssl_compability()
    - ak_libakrypt_set_password_read_function()


## Изменения в версии 0.8.2

 - Для блочных шифров Магма и Кузнечик реализована совместимость с openssl
    - для режима простой замены - полностью
    - для режима гаммирования - полностью для Кузнечика и только на длинах, кратных длине блока для Магмы

 - Возвращена и переименована в aktool консольная утилита, иллюстрирующая возможности библиотеки.
   Приведены примеры, см. man aktool, совместимости консольной утилиты и программы openssl
 - Изменен интерфейс большинства функций внешнего интерфейса для работы дескрипторами
   (реализация данных функций перемещена в файл ak_context_manager.c)
 - Механизм OID теперь поддерживает несколько имен для одного идентификатора
   (изменены тестовые примеры и интерфейс функций)
 - Изменена реализация и количество аргументов функции ak_ptr_to_hexstr()
 - Функция ak_ptr_to_hexstr_static() удалена


## Изменения в версии 0.8.1

 - Основная причина разработки новой ветки: получить совместимость по алгоритмам шифрования
   и имитозащиты с основными открытыми реализациями (OpenSSL, libgcrypt, etc). К началу разработки
   этой ветки совместимость обеспечивалась только для hash и hmac.
 - Изменено название собираемой библиотеки: теперь libakrypt.a или libakrypt.so
   (по-умолчанию собирается динамическая версия библиотеки)
 - Удален класс buffer
 - Изменен алгоритм вычисления контрольной суммы при хранении ключей в памяти
   Теперь используется алгоритм Флетчера и его модификации
 - Исправлен, а потом удален вовсе генератор xorshift32
 - Изменена реализация класса mac и, как следствие, реализация классов hash и hmac.
 - Добавлены новые тесты для hash и hmac (взамен тестов для класса mac)
 - Флаг -DLIBAKRYPT_INTERNAL_TESTS включает в сборку библиотеки ряд отладочных функций,
   используемых тестовыми приложениями.


## Изменения в версии 0.7.15

 - Добавлены функции умножения элементов в полях GF(2^256) и GF(2^512)
 - Оптимизирована реализация функций хеширования для big-endian архитектуры
 - Унифицирован вызов стандартных функций для работы с сокетами
 - В реализацию протокола sp fiot добавлена поддержка расширений requestIdentifier
 - Добавлена тестовая реализация ASN.1 парсера
 - Принято решение о переходе к ветке 0.8


## Изменения в версии 0.7.14

 - Изменения в функциях внешнего интерфейса:
   * добавлены функции для создания и применения объектов класса mac
   * удалены функции внешнего интерфейса для класса hash
   * реализованы функции для доступа к параметрам OID алгоритма по индексу и по дескриптору

 - Добавлены функции внутреннего инфтерфейса ak_mac_context_is_iv_settable() и ak_mac_context_get_iv_size()
 - Изменено внутреннее устройстро структуры mac,
   реализующей общий подход к реализации алгоритмов итерационного сжатия
 - Изменено внутреннее устройство структуры key_resource_counter, хранящей ресурс секретного ключа.
 - Факт установки ресурса ключа теперь привязан к моменту присвоения ключевого значения.
 - Добавлена краткая документация к утилите akrypt 


## Изменения в версии 0.7.13

 - Добавлена реализация режима работы блочных шифров:
   * ACPKM для шифрования данных ( функция ak_bckey_context_ctr_acpkm() )
 - Добавлен ряд служебных функций для работы с контекстами секретных ключей:
   * ak_skey_context_set_resource()
   * ak_skey_context_create_and_set_skey()
   * ak_bckey_context_create_and_set_bckey()
 - Название функции гаммирования для блочных шифров приведено к виду, соответствующему тексту стандарта,
   а именно ak_bckey_context_ctr()


## Изменения в версии 0.7.12

 - В состав библиотеки включена первая реализация протокола защищенного взаимодействия sp fiot.
 - Исправлена ошибка в реализации Кузнечика, из-за которой библиотека
   падала на некоторых комбинациях 32-х битной архитектуры, как правило Celeron, и компиляторов gcc и clang.
 - Исправлены баги в функции unmask() для алгоритма Магма (приведение указателя + разворот байт).
 - Исправлен баг при передаче длинных синхропосылок в ak_bckey_context_xcrypt().
 - Функция ak_buffer_alloc() теперь сохраняет предыдущие данные при увеличении длины буффера.
 - Добавлен ряд функций для работы с классом mac.
 - Добавлены функции сериализации/десериализации вычетов, используемые при хранении точек эллиптических кривых.
 - Добавлен генератор случайных чисел, предназначенный для считывания данных из сокетов домена unix.
 - Внесены небольшие изменения в документацию к библиотеке.
 - Уточнены процедуры инсталяции и деинсталяции библиотеки.
 - Возвращена консольная утилита akrypt (сборка утилиты может быть включена флагом cmake).


## Изменения в версии 0.7.11

 - Отлажена реализация блочных шифров "Кузнечик" и "Магма" для big endian архитектуры
 - Отлажена реализация режимов ecb, ctr, omac и mgm для big endian архитектуры
 - Исправлен баг шифрования коротких векторов в режимах xcrypt
 - Разрешен экспорт функции ak_log_set_level() (только для повышения уровня аудита)
 - Изменен флаг сборки библиотеки с --std=c11 на более ранний --std=c99
   (оказался нужен для поддержки ранних версий gcc)


## Изменения в версии 0.7.10

 - Начиная с этой версии не поддерживается алгоритм хеширования ГОСТ Р 34.11-94
 - Все остальные алгоритмы хеширования, а также основанные на них алгоритмы HMAC и PBKDF2,
   корректно выполняются на big endian архитектуре (протестированы arm32v7eb, mips32 и mips64)
 - Корректно выполняются на big endian архитектуре алгоритмы выработки и проверки электронной подписи.
 - Разделена сборка документации для различных форматов. Теперь доступны команды make html и make pdf.


## Изменения в версии 0.7.9

 - Сформировано ядро библиотеки - минимальный набор функций и тестовых примеров, позволяющий проводить
   тестирование процесса сборки без учета ошибок в реализации криптографических механизмов
 - Эллиптические кривые корректно тестируются под big endian архитектурой
 - Функции преобразования строк в большие целые числа  и обратно теперь учитывают архитектуру,
   на которой исполняется библиотека


## Изменения в версии 0.7.8

 - Исправлен ряд ошибок при сборке под x86_32 (компиляция asm вставок, тестирование архитектуры, поддержка Windows32 и т.д.)
 - Начата поддрежка big endian архитектуры (пока для операций в GF(2^n))


## Изменения в версии 0.7.7

 - Уточнена реализация алгоритма MGM,
   сделан вызов алгоритма выработки имитовставки MGM через интерфейс класса mac
 - Более аккуратно распределено включение стандартных заголовочных файлов

## Изменения в версии 0.7.6

 - Теперь сборка тестовых примеров производится только при установленном флаге
   -DLIBAKRYPT_INTERNAL_TESTS=ON при запуске cmake
 - Процедура тестирования криптографических механизмов вынесена в отдельную функцию
   ak_libakrypt_dynamic_control_test()
 - Немного оптимизирован механизм работы менеджера контекстов
 - Сделана корректная обработка рускоязычных имен файлов для консольного прилоджения akrypt (через gettext)
 - Исправлена ошибка выработки контрольной суммы для отсутствующих файлов (struct mac)


## Изменения в версии 0.7.5

 - Сделана реализация алгоритма выработки имитовставки ГОСТ Р 34.13-2015 через
   функции классы omac и mac
 - Исправлен ряд ошибок в реализации функций присвоения значений секретным ключам (класс skey)
 - Восстановлена реализация алгоритмов выработки и проверки электронной подписи.
 - Сделана возможность создания секретного ключа электронной подписи по идентификаторам (oid)
   алгоритма и эллиптической кривой.
 - Добавлен ряд тестов в механизм тестирования электронной подписи.
 - Переименование типов: ak_oid_engine -> oid_engines и ak_oid_mode -> oid_modes


## Изменения в версии 0.7.4

 - Изменена структура класса object, содержащая указатели на функции создания и
   удаления классов.
 - Исправлена реализация функции pbkdf2 и механизма генерации ключей из пароля (теперь
   пароль может быть произвольной, сколь угодно длинной последовательностью октетов)
 - Изменена (дополнена) структура класса bckey, изменено поведение режимов шифрования.
 - Исправлен механизм маскирования информации для ключей алгоритма Магма.
 - Изменена реализация алгоритма Магма (добавлено случайное блуждание).


## Изменения в версии 0.7.3

 - Класс compress удален. Его место занял класс mac, предназначенный для
   вычисления значений как бесключевых, так и ключевых функций хеширования.
 - Изменены названия функций присвоения ключевых значений. Цель переименования - привести в соответствие
   с правилами наименования функций, принятых в библиотеке.
 - Из класса skey удалена функция remask(), теперь ее роль выполняет функция set_mask().
 - Для класса skey введены флаги состояния контекста секретного ключа
  (флаг установки ключа, маски, наличия контрольной суммы)
 - Изменена реализация класса hmac


## Изменения в версии 0.7.2

 - Добавлена функция  int ak_random_context_create_oid( ak_random, ak_oid )
 - Добавлен класс генераторов ПДСЧ, регламентированных Р 1323565.1.006-2017
 - Добавлен тестовый пример для проверки корретности работы реализованных генераторов
   Общее количество генераторов в библиотеке доведено до семи
 - Тестирование механизма итеративного сжатия (compress) внесено в вызов функции ak_libakrypt_create()
 - Исправлены тестовые примеры для классов hash и compress


## Изменения в версии 0.7.1

 - Изменено лицензирование библиотеки: трехпунктовая лицензия DSB заменена на лицензию MIT.
   Текст лицензии удален из исходных текстов и перенесен в отдельный файл.
 - Изменен механизм наименования функций внутреннего интерфейса. Теперь все функции,
   работающие с контекстами, должны содержать в себе слово _context_
 - Исправлен механизм поиска файла с опциями. Теперь, при отсутствии файла,
   он создается в домашнем каталоге пользователя, запустившего библиотеку.
 - В механизм OID добавлен класс, позволяющий реализовывать конструирование и удаление
   объектов по известному значению OID.
 - Добавлен xorshift64* генератор псевдо-случайных чисел, представляющий собой
   линейный рагистр сдвига длины 64 бита с умножением, в качестве нелинейной функции усложнения.


## Изменения в версии 0.6.6

 - Поддерка libpthreads стала опциональной. Если библиотека не найдена,
   то ее использование прозрачно отключается.
 - Реализован механизм сохранения опций библиотеки в файле.
 - Исправлен механизм сборки документации + документация существенно дополнена
  (при сборке документации теперь дополнительно используется pandoc для разборки markdown файлов)


## Изменения в версии 0.6.5

 - Для функции ak_buffer_to_hexstr добавлен второй аргумент, управляющий порядком вывода байт
   (по аналогии с ak_ptr_to_hexstr)
 - Прогон санитайзера помог убрать некоторые проблемы с переполнением статических переменных
 - В процедуру сборки добавлен тест для проверки наличия операции умножения pcmulqdq
 - Отлажены и добавлены алгоритмы умножения элементов в полях Галуа большой размерности
   (необходимо для быстрой реализации российского aead-режима)
 - Сделана реализация режима шифрования с одновременной выработкой имитовставки
   (режим MGM), а таже набор тестов для проверки корректности реализации
 - Проведена успешная сборка и запуск консольного тестового приложения под Sailfish OS (arm32v7)


## Изменения в версии 0.6.4

 - Изменено поведение функции finalize() для контекстов бесключевого хеширования
  (теперь вызов функции не изменяет внутреннее состояние контекста, что позволяет
   после финализации продолжать далее обновлять состояния с помощью вызова update() )
 - Исправлен баг со значением контрольной суммы ключа при повторном использовании
   контекста секретного ключа (функция ak_skey_set_icode_xor())
 - Изменен механизм наименования примеров.
 - Добавлена цель make test для cmake. В батарею тестов включено тестирование
   арифметики больших чисел, а также все примеры с использованием внутреннего интерфейса.
 - Проведена первая успешная сборка библиотеки под MacOS.
 - Предпринята первая попытка привести документацию в порядок.
 - Изменен перечень тестовых примеров.


## Изменения в версии 0.6.3

 - Возвращена арифметика больших чисел и вычисления в группе точек
   эллиптической кривой (в короткой форме Вейерштрасса).
 - Исправлены ошибки в тестах проверки корректности реализации
   арифметических вычислений.
 - Тестирование вычислений на эллиптических кривых в короткой форме Вейерштрасса
   добавлено в вызов функции ak_libakrypt_create().
 - Уточнены поля структуры ak_oid_engine и работа функций, использующих данную структуру.
 - Предварительное описание функции проверки параметров контекста секретного ключа
   ak_skey_check() вынесено в заголовочный файл ak_skey.h
 - Подправлена реализация функции ak_wpoint_pow() - реализована лесенка Монтгомери,
   а также исправлен баг c изменением значений аргументов функции.
 - Реализованы функции создания контекстов секретного и открытого ключей
   электронной подписи, а также функции вычисления и проверки электронной подписи.
 - В вызов функции ak_libakrypt_create() добавлены тесты корректной работы
   для алгоритмов электронной подписи (выработка и проверка).


## Изменения в версии 0.6.2

 - Возвращена реализация алгоритма блочного шифрования Кузнечик.
   Теперь как с поддержкой 64-х битных операндов, так и 128-ми битных.
 - Изменена реализация функций выработки имитовставки, сделана единая структура
   для доступа к трем типам алгоритмов - hmac, на основе блочных шифров
   и электронной подписи.
 - Реализован механизм генерации секретных ключей для алгоритмов выработки имитовставки.
 - Проведена первая успешная сборка библиотеки под FreeBSD.


## Изменения в версии 0.6.1

 - Минимизирован перечень необходимых функций.
 - Протестирована сборка библиотеки для компиляторов gcc, clang, tcc, mingw и msvc


Версия 0.6 появилась в связи с изменением интерфейса пользовательских функций,
предназначенных для вычисления имитовставок и кодов целостности.
